{    Delphi}


{    ,    
   MaxWidth, MaxHeight; ,   
 ExcludedForms,   }
procedure AppScaleForms(FormsComponent: TComponent;
  MaxWidth, MaxHeight: Integer; ExcludedForms: array of const);
{    ,     
           
 }
procedure ApplicationTerminate;
{True -    (   , 
ActiveX- )}
function CheckComponent(ComponentClass: TComponentClass): Boolean;
{  :  ( FontName   ), 
( FontSize  0)  FontCharset (  -   0-255)}
procedure DefineFont(Font: TFont; const FontName: string;
  FontSize, FontCharset: Integer);
{  TextAttributes    ,    Font}
procedure FontToTextAttributes(Font: TFont; TextAttributes: TTextAttributes);
{  Font    ,    TextAttributes}
procedure TextAttributesToFont(TextAttributes: TTextAttributes; Font: TFont);

{      RichEdit}
procedure RichEditScrollDown(const RichEdit: TRichEdit);
{      RichEdit  Value 
   }
procedure RichEditScrollAdd(RichEdit: TRichEdit; const Value: string);
{  FindText   FindOptions   
RichEdit,      (-1),    }
function RichEditFindText(RichEdit: TRichEdit; const FindText: string;
  FindOptions: TFindOptions): Integer;
{     RichEdit,   FindDialog,
    ParentWnd,    
AllowDlgShowing,         
FindFinishedMsgShowed,   True    
    ,    OK, 
 WndCaption}
function RichEditFind(ParentWnd: HWND; FindDialog: TFindDialog;
  RichEdit: TRichEdit; const WndCaption: string; AllowDlgShowing: Boolean;
  var FindFinishedMsgShowed: Boolean): Boolean;
{      RichEdit, , 
   HeaderPrefix,  ,   
 CategoryPrefix  ,   ,
      ,  ,  
  , ,   
      ,  }
procedure RichEditColorer(RichEdit: TRichEdit; const HeaderPrefix,
  CategoryPrefix: string);

{   StrBlock      GetStrFromArray
 IsMulti     ListView,   Sender,  
nil, Mode    , Params ,  
       StrBlockToFieldsValues,
    }
procedure StrBlockToListView(const StrBlock: string; IsMulti: Boolean;
  ListView: TListView; Sender: TObject; const Mode, Params: string;
  StrBlockToFieldsValues: TStrBlockToFieldsValuesEvent);

{   ListItems, , , 
TListView.Items,    IndexedStringsList}
procedure RetrieveListItems(ListItems: TListItems;
  IndexedStringsList: TIndexedStringsList);
{   ListItems, , , 
TListView.Items,    IndexedStringsList,  IsSorted 
 }
procedure UpdateListItems(ListItems: TListItems;
  IndexedStringsList: TIndexedStringsList; IsSorted: Boolean);
{    ListView   
     IndexedStringsList,  IsSorted 
 }
procedure UpdateListView(ListView: TListView;
  IndexedStringsList: TIndexedStringsList; IsSorted: Boolean);
{   Address,     Value
        ,
      }
procedure ListItemHexView(ListItem: TListItem; Address: Integer;
  const Value: string);
{   FileListBox     }
procedure FileListBoxUpdate(FileListBox: TFileListBox);

{    TreeNodes, , ,
 TTreeView.Items,   Strings,     
         }
procedure RetrieveTreeNodes(TreeNodes: TTreeNodes; Strings: TStrings);
{   ParentTreeNode  TreeNodes, ,
,  TTreeView.Items,   Hierarchy,  
        ExtractFunc
       ChildExtractFunc  }
procedure UpdateTreeNodes(TreeNodes: TTreeNodes; ParentTreeNode: TTreeNode;
  Hierarchy: PHierarchy; ExtractFunc, ChildExtractFunc: TExtractFunc);

{     FieldType   }
function FieldTypeToVarBaseType(FieldType: TFieldType): TVarBaseType;
{    DBGrid   Strings   
       ,   Null
  NullStr,  HexBinary  True  
BLOB-    }
procedure DBGridSelectedRowsToStrings(DBGrid: TDBGrid; const NullStr: string;
  HexBinary: Boolean; Strings, LastValues: TStrings);
{  TableName    SQL-  CommandType
    DBGrid ,    
 KeyColumnsCount    ,   
, SQLDivider   SQL-, , 'GO',  
  SQL-  ';', LineLength  
   SQL-}
function DBGridSelectedRowsToSQLs(CommandType: TSQLCommandType;
  const TableName: string; DBGrid: TDBGrid; KeyColumnsCount: Integer;
  const SQLDivider: string; LineLength: Integer): string;

{$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
{$IFNDEF VER110} {$IFNDEF VER120} {$IFNDEF VER125}
{   SMTP- Host    UserId,
  FromName c  FromAddress      ToName,  
    ,    
 ToAddress,        ,
  Subject,  Body, :
SendMail('123.45.67.89:25', 'user', 'Ivanov I.I.', 'ivanov@mail.ru',
'Petrov P.P.', 'petrov@mail.ru', '', '')}
procedure SendMail(const Host, UserId, FromName, FromAddress, ToName,
  ToAddress, Subject, Body: string);
{$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}

{      }
type
  TAppMinimize = class(TObjectStd)
  private
    FMinimized: Boolean;
    FHandleArray: string;
    FActiveForm: TForm;
    FFormEnabled: Boolean;
  protected
  public
    constructor Create;
    {}
    procedure Minimize(ActiveForm: TForm);
    procedure Restore;
    {}
    property Minimized: Boolean read FMinimized;
  end;
{     TAppMinimize,  
 -   }
function AppMinimize: TAppMinimize;
{   }
procedure AppMinimizeReset;

{ ,        
   IsSysDebug  True (TFormDbg);   (TFormStd)}
type
  TFormDbg = class(TForm)
  private
  protected
  public
    constructor Create(AOwner: TComponent); override;
    constructor CreateNew(AOwner: TComponent
      {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
      {$IFNDEF VER110}
      ; Dummy: Integer = 0
      {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
      );
      {$IFNDEF VER80} {$IFNDEF VER90} {$IFNDEF VER93} {$IFNDEF VER100}
      {$IFNDEF VER110}
      override;
      {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF} {$ENDIF}
    destructor Destroy; override;
  end;
  TFormStd = {$IFNDEF NODEBUG_SYS} TFormDbg {$ELSE} TForm {$ENDIF};

{      }
type
  TFormMin = class(TFormStd)
  private
    procedure WMSysCommand(var Message: TWMSysCommand); message WM_SYSCOMMAND;
  protected
  public
  end;

{$IFDEF VER140}
{     }
type
  TSpinEdit = class(TEdit)
  private
    FMinValue: LongInt;
    FMaxValue: LongInt;
    FIncrement: LongInt;
    FEditorEnabled: Boolean;
  protected
    function GetValue: LongInt;
    procedure SetValue(NewValue: LongInt);
  public
    constructor Create(AOwner: TComponent); override;
  published
    property EditorEnabled: Boolean
      read FEditorEnabled write FEditorEnabled default True;
    property Increment: LongInt read FIncrement write FIncrement default 1;
    property MaxValue: LongInt read FMaxValue write FMaxValue;
    property MinValue: LongInt read FMinValue write FMinValue;
    property Value: LongInt read GetValue write SetValue;
  end;
{$ENDIF}

{   GIF  PCX   
(ImagesSupportInit);    GIF  PCX  (ImagesSupportReset)}
procedure ImagesSupportInit;
procedure ImagesSupportReset;
{  Value   }
procedure GraphicClassSupportDestroy(Value: Pointer);
{   Picture,    Brightness, 
100    }
procedure PictureBrightness(Picture: TPicture; Brightness: Extended);
{  Picture    Quaters  
  }
procedure PictureRotate(Picture: TPicture; Quaters: Integer);
{       MinColor  
 ,          
   FrameWidth,     
    MaxPointWidth      
PointFrameWidth}
procedure PictureCleaning(Picture: TPicture; MinColor, FrameWidth,
  MaxPointWidth, PointFrameWidth: Integer);
{     24-  Bitmap,
Width   , Height   , MinValue 
   , MaxValue   
 , StepValue       ,
     , MinResult 
   , MaxResult   
 , Color  ,  Rotate  True  
 ,       
     ,    ,  
           
   (BitmapAxis);    24-  Bitmap
    Point1     Point2  Color,
 SkipFirst     Point1,   
    ,       
(BitmapLine);      Picture, MinValue 
    , MaxValue   
  , StepValue        ,
MinResult      , MaxResult 
    , StepResult     
  , CalculateMethod     
,  Colors   4-  ,  24-
  ,     
(PictureGraphics)}
procedure BitmapAxis(Bitmap: TBitmap; Width, Height: Integer;
  MinValue, MaxValue, StepValue, MinResult, MaxResult: Extended;
  const Color: TPixelInfo; Rotate: Boolean);
procedure BitmapLine(Bitmap: TBitmap; const Point1, Point2: TPoint;
  const Color: TPixelInfo; SkipFirst: Boolean);
procedure PictureGraphics(Picture: TPicture; MinValue, MaxValue,
  StepValue, MinResult, MaxResult, StepResult: Extended;
  CalculateMethod: TCalculateMethod; const Colors: string);
{  ,        
   IsSysDebug  True (TBitmapDbg);  
 (TBitmapStd)}
type
  TBitmapDbg = class(TBitmap)
  private
  protected
  public
    constructor Create; override;
    destructor Destroy; override;
  end;
  TBitmapStd = {$IFNDEF NODEBUG_SYS} TBitmapDbg {$ELSE} TBitmap {$ENDIF};
{  JPEG,        
   IsSysDebug  True (TJPEGImageDbg);  
 (TJPEGImageStd)}
type
  TJPEGImageDbg = class(TJPEGImage)
  private
  protected
  public
    constructor Create; override;
    destructor Destroy; override;
  end;
  TJPEGImageStd = {$IFNDEF NODEBUG_SYS} TJPEGImageDbg {$ELSE} TJPEGImage
    {$ENDIF};
{  JPEG,        
   IsSysDebug  True (TJPEGImageDbg);  
 (TJPEGImageStd)}
type
  TPictureDbg = class(TPicture)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TPictureStd = {$IFNDEF NODEBUG_SYS} TPictureDbg {$ELSE} TPicture {$ENDIF};

{ GIF,  Endre I. Simay, sunibmp 2.02, endre_s@freestart.hu}
type
  EGIFError = class(ExceptionStd);
  TGIFBitmap = class(TBitmapStd)
  private
    FTransparentColor: TColor;
    FLoaded: Boolean;
  protected
    function GetTransparentColor: TColor;
  public
    constructor Create; override;
    procedure LoadFromStream(Stream: TStream); override;
    property TransparentColor: TColor read GetTransparentColor;
  end;
{  GIF    (GIFSupportInit);  
GIF (GIFSupportReset)}
procedure GIFSupportInit;
procedure GIFSupportReset;

{ PCX,  Endre I. Simay, sunibmp 2.02, endre_s@freestart.hu}
type
  EPCXError = class(ExceptionStd);
  TPCXBitmap = class(TBitmapStd)
  private
  protected
  public
    procedure LoadFromStream(Stream: TStream); override;
  end;
{  PCX    (PCXSupportInit);  
PCX (PCXSupportReset)}
procedure PCXSupportInit;
procedure PCXSupportReset;

