{   Variant}


{---    --------------------------------------------------------}

{  OLE }
type
  POleVariant = ^OleVariant;
  TOleVariantArray =
    array[0..High(Integer) div SizeOf(OleVariant) - 1] of OleVariant;
  POleVariantArray = ^TOleVariantArray;
{     ParamNNN}
type
  TObjVMethod = function: Variant of object;
  TObjV1Method = function(const Param1: Variant): Variant of object;
  TObjV2Method = function(const Param1, Param2: Variant): Variant of object;
  TObjV3method = function(const Param1, Param2, Param3: Variant):
    Variant of object;
  TObjV4Method = function(const Param1, Param2, Param3, Param4: Variant):
    Variant of object;
  TObjV5Method = function(const Param1, Param2, Param3, Param4, Param5:
    Variant): Variant of object;
  TObjV6Method = function(const Param1, Param2, Param3, Param4, Param5, Param6:
    Variant): Variant of object;
  TObjV7Method = function(const Param1, Param2, Param3, Param4, Param5, Param6,
    Param7: Variant): Variant of object;
  TObjV8Method = function(const Param1, Param2, Param3, Param4, Param5, Param6,
    Param7, Param8: Variant): Variant of object;
  TObjV9Method = function(const Param1, Param2, Param3, Param4, Param5, Param6,
    Param7, Param8, Param9: Variant): Variant of object;
  TObjV10Method = function(const Param1, Param2, Param3, Param4, Param5,
    Param6, Param7, Param8, Param9, Param10: Variant): Variant of object;
  TObjV11Method = function(const Param1, Param2, Param3, Param4, Param5,
    Param6, Param7, Param8, Param9, Param10, Param11: Variant): Variant
    of object;
  TObjV12Method = function(const Param1, Param2, Param3, Param4, Param5,
    Param6, Param7, Param8, Param9, Param10, Param11, Param12: Variant):
    Variant of object;
  TObjV13Method = function(const Param1, Param2, Param3, Param4, Param5,
    Param6, Param7, Param8, Param9, Param10, Param11, Param12, Param13:
    Variant): Variant of object;
  TObjV14Method = function(const Param1, Param2, Param3, Param4, Param5,
    Param6, Param7, Param8, Param9, Param10, Param11, Param12, Param13,
    Param14: Variant): Variant of object;
  TObjV15Method = function(const Param1, Param2, Param3, Param4, Param5,
    Param6, Param7, Param8, Param9, Param10, Param11, Param12, Param13,
    Param14, Param15: Variant): Variant of object;



{---    -----------------------------------------}



{---     ------------------------------------------------}

{     P   ,   
  8 }
function ObjVMethodToStr(P: TObjVMethod): string;
function ObjV1MethodToStr(P: TObjV1Method): string;
function ObjV2MethodToStr(P: TObjV2Method): string;
function ObjV3MethodToStr(P: TObjV3Method): string;
function ObjV4MethodToStr(P: TObjV4Method): string;
function ObjV5MethodToStr(P: TObjV5Method): string;
function ObjV6MethodToStr(P: TObjV6Method): string;
function ObjV7MethodToStr(P: TObjV7Method): string;
function ObjV8MethodToStr(P: TObjV8Method): string;
function ObjV9MethodToStr(P: TObjV9Method): string;
function ObjV10MethodToStr(P: TObjV10Method): string;
function ObjV11MethodToStr(P: TObjV11Method): string;
function ObjV12MethodToStr(P: TObjV12Method): string;
function ObjV13MethodToStr(P: TObjV13Method): string;
function ObjV14MethodToStr(P: TObjV14Method): string;
function ObjV15MethodToStr(P: TObjV15Method): string;



{---   ------------------------------------------------------}

{     '0'  '1',   ,
    ,      }
function VarBoolToStr(const Value: Variant): string;
{  V    Value,   
False,   Value   False (VarToBoolConv);   
DefValue (VarToBoolDef)}
function VarToBoolConv(const V: Variant; out Value: Boolean): Boolean;
function VarToBoolDef(const V: Variant; DefValue: Boolean): Boolean;
{      , 
Null, Value  }
function NullBoolToVar(const Value: TNullBool): Variant;
{  V       ,
 Null Value,       
  ,  Null,   
False, Value  Null (VarToNullBoolConv);   
DefValue (VarToNullBoolDef)}
function VarToNullBoolConv(const V: Variant;
  out Value: TNullBool): Boolean;
function VarToNullBoolDef(const V: Variant;
  const DefValue: TNullBool): TNullBool;



{---   -------------------------------------------------------}

{   Value  ,  ,    
,   ,   }
function VarIntToStr(const Value: Variant): string;
{  V   Value,    False, Value = 0,
     ,  , 
High(Integer) (VarToIntConv);  DefValue   (VarToIntDef)}
function VarToIntConv(const V: Variant; out Value: Integer): Boolean;
function VarToIntDef(const V: Variant; DefValue: Integer): Integer;
{      ,  Null,
Value  }
function NullIntToVar(const Value: TNullInt): Variant;
{  V       ,
 Null Value,       
  ,  Null,   
False, Value  Null (VarToNullIntConv);   
DefValue (StrToNullIntDef)}
function VarToNullIntConv(const V: Variant; out Value: TNullInt): Boolean;
function VarToNullIntDef(const V: Variant; const DefValue: TNullInt): TNullInt;
{   Value  ,   ,
       , ,
  ,    (VarFloatToStr); 
   (VarCurrToStr)}
function VarFloatToStr(const Value: Variant): string;
function VarCurrToStr(const Value: Variant): string;
{ FloatToStrFormat  CurrToStrFormat,    
Value      ,  
       (VarFloatToStrFormat,
VarCurrToStrFormat)}
function VarFloatToStrFormat(const Value: Variant; DecimalSeparator: Char;
  Decimals: Integer): string;
function VarCurrToStrFormat(const Value: Variant; DecimalSeparator: Char;
  Decimals: Integer): string;
{ VarFloatToStrFormat  VarCurrToStrFormat, ,
SeparatorAndDecimals      ,
   ".",      
 ,    2 (VarFloatToStrFormatCombo,
VarCurrToStrFormatCombo)}
function VarFloatToStrFormatCombo(const Value: Variant;
  const SeparatorAndDecimals: string): string;
function VarCurrToStrFormatCombo(const Value: Variant;
  const SeparatorAndDecimals: string): string;
{  V    Value,  
 = False, Value = 0,      
 '.', ',', '-', '=',   Windows (VarToFloatConv);
 DefValue   (VarToFloatDef);   Value,  
 False, Value = 0 (VarToCurrConv);  DefValue  
(VarToCurrDef)}
function VarToFloatConv(const V: Variant; out Value: Extended): Boolean;
function VarToFloatDef(const V: Variant; DefValue: Extended): Extended;
function VarToCurrConv(const V: Variant; out Value: Currency): Boolean;
function VarToCurrDef(const V: Variant; DefValue: Currency): Currency;
{      , 
Null Value,   (NullFloatToVar),   
(NullCurrToVar)}
function NullFloatToVar(const Value: TNullFloat): Variant;
function NullCurrToVar(const Value: TNullCurr): Variant;
{  V       ,
 Null Value,       
  ,  Null,   
False, Value  Null (VarToNullFloatConv);   
DefValue (VarToNullFloatDef);    
(VarToNullCurrConv, VarToNullCurrDef)}
function VarToNullFloatConv(const V: Variant; out Value: TNullFloat): Boolean;
function VarToNullFloatDef(const V: Variant;
  const DefValue: TNullFloat): TNullFloat;
function VarToNullCurrConv(const V: Variant; out Value: TNullCurr): Boolean;
function VarToNullCurrDef(const V: Variant;
  const DefValue: TNullCurr): TNullCurr;
{ ExportNumAsText, ,     , 
 }
function VarExportNumAsText(const Value: Variant): string;



{---      ---------------------------------------------}

{  Year,   ,      , 
Year   ,    Year}
function VarCorrectYear(const Year: Variant): Variant;
{        Day,  Month,  Year,
 Hour,  Minute,  Second,  Milliseconds, 
    ,    , 
Null,    ,      
CorrectYear}
function VarDateTime(const Day, Month, Year, Hour, Minute, Second,
  Milliseconds: Variant): TNullDateTime;
{ DateTimeToStrFormat,       
 ,         }
function VarDateTimeToStrFormat(const Value: Variant;
  const Format: string): string;
{ Format       
StrToDateFullStrMode,     Value   
   NullDateToFullStr,      
  VarDateTimeToStrFormat}
function VarDateTimeToStrFormatCombo(const Value: Variant;
  const Format: string): string;
{ DateTimeToStr,    Value,     
      (VarTimeToStr, VarDateToStr,
VarDateTimeToStr)}
function VarTimeToStr(const Value: Variant): string;
function VarDateToStr(const Value: Variant): string;
function VarDateTimeToStr(const Value: Variant): string;
{ StrToDateTimeConv, StrToDateTimeDef   V (VarToDateTimeConv,
VarToDateTimeDef)}
function VarToDateTimeConv(const V: Variant; out Value: TDateTime): Boolean;
function VarToDateTimeDef(const V: Variant; DefValue: TDateTime): TDateTime;
{ NullDateTimeToStr  }
function NullDateTimeToVar(const Value: TNullDateTime): Variant;
{ StrToNullDateTimeConv, StrToNullDateTimeDef   V
(VarToNullDateTimeConv, VarToNullDateTimeDef)}
function VarToNullDateTimeConv(const V: Variant;
  out Value: TNullDateTime): Boolean;
function VarToNullDateTimeDef(const V: Variant;
  const DefValue: TNullDateTime): TNullDateTime;



{---    ----------------------------------------------------}

{  V    Value,     False,
 Value    (VarToStrConv),  DefValue
(VarToStrDef),       (VarToWideStrConv,
VarToWideStrDef)}
function VarToStrConv(const V: Variant; out Value: string): Boolean;
function VarToStrDef(const V: Variant; const DefValue: string): string;
function VarToWideStrConv(const V: Variant; out Value: WideString): Boolean;
function VarToWideStrDef(const V: Variant; const DefValue: WideString):
  WideString;
{      , 
Null, Value  }
function NullStrToVar(const Value: TNullStr): Variant;
{  V       ,
 Null (VarToNullStrConv),    DefValue
(VarToNullStrDef)}
function VarToNullStrConv(const V: Variant; out Value: TNullStr): Boolean;
function VarToNullStrDef(const V: Variant;
  const DefValue: TNullStr): TNullStr;
{  S  Value   AType   Null,  
 False,  Value  Null (StrToTypeConv);  
 DefValue (StrToTypeDef);    DefIntValue 
   , DefFloatValue    
, DefCurrValue -  , DefDateTimeValue -    ,
DefBoolValue -   (StrToTypeDefs); ,    
  0,  , False (StrToTypeCast);   S
  AType   Null,    ErrorMsg   
 ,   Null (StrToTypeError)}
function StrToTypeConv(const S: string; AType: TVarBaseType;
  out Value: Variant): Boolean;
function StrToTypeDef(const S: string; AType: TVarBaseType;
  const DefValue: Variant): Variant;
function StrToTypeDefs(const S: string; AType: TVarBaseType;
  DefIntValue: Integer; DefFloatValue: Extended; DefCurrValue: Currency;
  DefDateTimeValue: TDateTime; DefBoolValue: Boolean): Variant;
function StrToTypeCast(const S: string; AType: TVarBaseType): Variant;
function StrToTypeError(const S: string; AType: TVarBaseType;
  out ErrorMsg: string): Variant;

{ ValueIfTrue,  IfCase = True  ValueIfFalse   }
function IIfVar(IfCase: Boolean; const ValueIfTrue,
  ValueIfFalse: Variant): Variant;
{ TruncStr     V,   ,  
 Null  Unassigned,   }
function VarTruncStr(const V: Variant; MaxLen: Integer): Variant;

{   Value      
    (RusStrToVar);  
  Value      
   (RusVarToStr)}
function StrToVar(const Value: string): OleVariant;
function VarToStrStd(const Value: OleVariant): string;
{  Value  OleVariant    
        
}
function VarToOle(const Value: Variant): OleVariant;



{---    ---------------------------------------------------}

{     ,  Null}
type
  TNullVar = record
    NotNull: Boolean;
    Value: Variant;
  end;
{   Value (InitNullVar);  TNullVar  NotNull,
,     Null,   
Value (NullVar)}
procedure InitNullVar(out Value: TNullVar);
function NullVar(NotNull: Boolean; const Value: Variant): TNullVar;
{    }
function EmptyParamStd: OleVariant;
{     ,  }
function VarRecToStrFull(const VarRec: TVarRec): string;
{     }
function VarRecToVariant(const VarRec: TVarRec): Variant;
{  V   VarType,   V  Unassigned   Null;
    V}
function InitedVarAsType(const V: Variant; VarType: Integer): Variant;
{     V  ,    
  (VarArrayToStr);   S     
(StrToVarArray)}
function VarArrayToStr(const V: Variant): string;
function StrToVarArray(const S: string): Variant;
{  Variant   , MBCT-   
  WideToByteStr,     
(VariantToByteStr);   Variant    S   MBCT-,
     S   (ByteStrToVariant);
  MBCT-   V  Len,   
 ,      0
(ByteStrVariantCorrect)}
function VariantToByteStr(const V: OleVariant): string;
function ByteStrToVariant(const S: string): OleVariant;
function ByteStrVariantCorrect(var V: OleVariant; Len: Integer): Integer;
{ VariantToByteStr,      MBCT- 
VarArrayToStr  ToStr (ToByteStr);    S  , 
    MBCT-,     
StrToVarArray (FromByteStr)}
function ToByteStr(const V: Variant): string;
function FromByteStr(const S: string): Variant;
{  V      
 ,  ToStr, WideToStr, VarArrayToStr}
function ToStrAuto(const V: Variant): string;
{ Unassigned  Null  V}
function AVarNull(const V: Variant): Variant;
{ Unassigned  Null  V        }
function StrVar(const V: Variant): string;
{      varTypeMask (  
varArray);  VarIsEmpty(V) = True,  varEmpty, 
VarIsNull(V) = True,  varNull}
function MaskedVarType(const V: Variant): Integer;
{      }
function VarInfo(const V: Variant): string;
{ Value   '(empty)'  Unassigned,  varEmpty, '(null)'
 Null,  varNull, (empty-dispatch)   varDispatch,
(empty-unknown)   varUnknown,  ( ): 
  ,     'i'  , 'f' 
, 'c'  , 'd'    , 'b'  , 's'
 , 'o'     ,    
 'a',   'r',       varInteger,
varDouble, varCurrency, varDate, varBoolean, varOleStr, varDispatch, 
varOleStr,           ,
         (V); 
,     V,   (ToV);  
 Value   ,    ,
, ,       ,   
  'Null'     Null,   'Unassigned'
    Unassigned (AsV)}
function V(const Value: Variant): string;
function ToV(const Value: string): Variant;
function AsV(const Value: string): Variant;
{  V    VarType   
Windows,       Value  
True,   Value = Unassigned,  = False;   
(MaskedVarType(V) = varDispatch) and (not VarIsEmpty(V)) and
(not VarIsNull(V) and (VarType <> varDispatch) and (VarType <> varAny)}
function VarCastTypeConv(const V: Variant; VarType: Integer;
  out Value: Variant): Boolean;
{    V}
function VarBaseType(const V: Variant): TVarBaseType;
{ True,   V     }
function VarIsWide(const V: Variant): Boolean;
{  V      ,   
 System.VarToStr}
function VarToWide(const V: Variant): WideString;
{ True,    Null  Unassigned}
function VarIsNullStd(const V: Variant): Boolean;
{ True,    Null, Unassigned,  
    }
function VarIsClear(const V: Variant): Boolean;
{  V   ,   False (ToBool), 
 ,   0 (ToInt),       
(-1) (ToIntMinOne),   ,   0 (ToFloat),  ,
  0 (ToCurr),    ,    
(ToDateTime),  ,     (ToStr),   
 ,     (ToWideStr), 
 ,  ,  Null,  
 ,  Null (ToNullBool, ToNullInt,
ToNullIntMinOne, ToNullFloat, ToNullCurr, ToNullDateTime, ToNullStr)}
function ToBool(const V: Variant): Boolean;
function ToInt(const V: Variant): Integer;
function ToIntMinOne(const V: Variant): Integer;
function ToFloat(const V: Variant): Extended;
function ToCurr(const V: Variant): Currency;
function ToDateTime(const V: Variant): TDateTime;
function ToStr(const V: Variant): string;
function ToWideStr(const V: Variant): string;
function ToNullBool(const V: Variant): TNullBool;
function ToNullInt(const V: Variant): TNullInt;
function ToNullFloat(const V: Variant): TNullFloat;
function ToNullCurr(const V: Variant): TNullCurr;
function ToNullDateTime(const V: Variant): TNullDateTime;
function ToNullStr(const V: Variant): TNullStr;
{  V   ,  Null - '(NULL)',
Unassigned - '(EMPTY)'}
function ToDisplay(const V: Variant): string;
{  V  ,  
  (AsBool),  (AsInt),  
(AsFloat),  (AsCurr),    (AsDateTime),  (AsChar),
 (AsStr)}
function AsBool(const V: Variant): Boolean;
function AsInt(const V: Variant): Integer;
function AsFloat(const V: Variant): Extended;
function AsCurr(const V: Variant): Currency;
function AsDateTime(const V: Variant): TDateTime;
function AsChar(const V: Variant): Char;
function AsStr(const V: Variant): string;
{,   -     -  V 
 (IsBool),   (IsInt),   (IsFloat), 
(IsCurr),    (IsDateTime),   (IsChar), ,  Null
(IsStr)}
function IsBool(const V: Variant): Boolean;
function IsInt(const V: Variant): Boolean;
function IsFloat(const V: Variant): Boolean;
function IsCurr(const V: Variant): Boolean;
function IsDateTime(const V: Variant): Boolean;
function IsChar(const V: Variant): Boolean;
function IsStr(const V: Variant): Boolean;
{,   -     -  V  
   MinValue  MaxValue,  ,  Null,  
}
function IsIntRange(const V: Variant; const MinValue,
  MaxValue: TNullInt): Boolean;
{  V  Value   AType   Null,  
 False,  Value  Null (VarToTypeConv);  
 DefValue (VarToTypeDef);    DefIntValue 
   , DefFloatValue    
, DefCurrValue -  : DefDateTimeValue -    ,
DefBoolValue -  , DefStrValue -   (VarToTypeDefs); ,
      0,  , False,  
(VarToTypeCast);     V   AType
(VarConvError);   V   AType  , 
NotAllowNull = True     Null  , 
       ,   0,  ,
 , ValueIfFalse ,     False,
ValueIfTrue ,     True,  
ValueIfFalse  ValueIfTrue   , DateTimeFormat
     ,    
    ,  BinaryHex  True
      (VarToStrMode)}
function VarToTypeConv(const V: Variant; AType: TVarBaseType;
  out Value: Variant): Boolean;
function VarToTypeDef(const V: Variant; AType: TVarBaseType;
  const DefValue: Variant): Variant;
function VarToTypeDefs(const V: Variant; AType: TVarBaseType;
  DefIntValue: Integer; DefFloatValue: Extended; DefCurrValue: Currency;
  DefDateTimeValue: TDateTime; DefBoolValue: Boolean;
  DefStrValue: string): Variant;
function VarToTypeCast(const V: Variant; AType: TVarBaseType): Variant;
function VarConvError(const V: Variant; AType: TVarBaseType): string;
function VarToStrMode(const V: Variant; AType: TVarBaseType;
  NotAllowNull: Boolean; const ValueIfFalse, ValueIfTrue,
  DateTimeFormat: string; BinaryHex: Boolean): string;
{  Value  ,   ,  
TVarBaseType,      btBinary,  Unassigned
  Null,   ,    ,
   (VarExport);     ExportStr,
 VarExport (VarImport)}
function VarExport(const Value: Variant): string;
function VarImport(const ExportStr: string): Variant;
{  Value    Visual Basic,   
'null'   Null, 'true'  'false'   , ,
     ,    
StrToCPPStyleText(ToStr(Value), '', #149, False, True, True) (VBVarExport);
     ExportStr (VBVarImport)}
function VBVarExport(const Value: Variant): string;
function VBVarImport(const ExportStr: string): Variant;
{  Value  TVariant   (VariantToVar);  
   TVariant (VarToVariant);    VarType
    Value   (NullVarValueToVar);
  Value    VarType     
TNullVarValue (VarToNullVarValue)}
function VariantToVar(const Value: TVariant): Variant;
function VarToVariant(const Value: Variant): TVariant;
function NullVarValueToVar(VarType: TVarBaseType;
  const Value: TNullVarValue): Variant;
function VarToNullVarValue(VarType: TVarBaseType;
  const Value: Variant): TNullVarValue;

{     (UpperCaseVariant),  
(LowerCaseVariant),       (LowerCaseVariant),
      (LangLowerCaseVariant),  
    CaseMode (ChangeCaseVariant);  ,
  ,       ;
  }
function UpperCaseVariant(const V: Variant): Variant;
function LowerCaseVariant(const V: Variant): Variant;
function LangUpperCaseVariant(const V: Variant): Variant;
function LangLowerCaseVariant(const V: Variant): Variant;
function ChangeCaseVariant(const V: Variant; CaseMode: TCaseMode): Variant;

{  Value1  Value2,  Value1 = Value2,  = 0, 
Value1 > Value2,  > 0,   < 0, Unassigned 
  , Null -  ,  Unassigned (CompareVar);
     CompareMode, Null   
,     Null,  0,  
-       
(CompareVarMode);   Value1  Value2  AType  
CompareMode, Null  Unassigned    False, 0,  
  ,  Value1 = Value2,  = 0,  Value1 > Value2,
 > 0,   < 0 (CompareTypedVar); 
CompareTypedVar,      , 
Null (CompNullTypedVar)}
function CompareVar(const Value1, Value2: Variant): Integer;
function CompareVarMode(const Value1, Value2: Variant;
  CompareMode: TCompareMode): Integer;
function CompareTypedVar(const Value1, Value2: Variant;
  AType: TVarBaseType; CompareMode: TCompareMode): Integer;
function CompNullTypedVar(const Value1, Value2: Variant;
  AType: TVarBaseType; CompareMode: TCompareMode): Integer;
{ True,   - Null,  ,  , 0,
 , False}
function VarIsNone(const V: Variant): Boolean;
{  V,    ,   }
function TrimVar(const V: Variant): Variant;
{   V  , IndexesStr   
   4- ,    V, DefValue 
  ,  ,    
      }
function VarArrayGetItem(const V: Variant; const IndexesStr: string;
  const DefValue: Variant): Variant;
{   V  , IndexesStr   
   4- , Value  , V  
 ,     ,    
,   -  ,     
  ,  ,    V   
 Unassigned,     ,     IndexesStr
  0,    Unassigned}
procedure VarArraySetItem(var V: Variant; const IndexesStr: string;
  const Value: Variant);
{    Dict, ,   ,
    ,   
 ,     
 ,     Module, ,
  ,      
Section, ,   ,   
   Index,        ,
      DefValue}
function TD(const Dict: Variant; Module, Section, Index: Integer;
  const DefValue: Variant): Variant;
{      Number,   1, 
  Params,      ,
 DefValue (VarPrmDef);    
  Number,   1,    Params,   
  ,  Unassigned (VarPrm);  
    Number,   1,    Params,
   True,       ,
 False (VarSet);   Value    
AResult,  ,    AResult   nil,
    True,      ,
 False (VarRes);      Params
(VarPrmsToStr);     AResult,  nil,
 DefValue (VarResToStr)}
function VarPrmDef(Params: PDispParams; Number: Integer;
  const DefValue: OleVariant): OleVariant;
function VarPrm(Params: PDispParams; Number: Integer): OleVariant;
function VarSet(Params: PDispParams; Number: Integer;
  const Value: OleVariant): Boolean;
function VarRes(AResult: POleVariant; const Value: OleVariant): Boolean;
function VarPrmsToStr(Params: PDispParams): string;
function VarResToStr(AResult: POleVariant; DefValue: string): string;



{---     ---------------------------------------------}



{---   ------------------------------------------------------------}



{---   --------------------------------------------------------}



{---  ------------------------------------------------------------------}



{---  ----------------------------------------------------------------}



{---  -----------------------------------------------------------------}



{---   -------------------------------------------------------}



{---  ------------------------------------------------------------------}



{---   -------------------------------------------------------------}

{  Value      SQL-  
  AType,   Empty  Null      
 'NULL',     '0'  '1',
  ,     '.',
     SQLDate  SQLStr, ,
    ,    
    '0x'  ''''   }
function SQLVar(const Value: Variant; AType: TVarBaseType): string;



{---  --------------------------------------------------------------------}



{--- Web- ------------------------------------------------------------}

{          ErrorCode, 
 ,  CallWindowsIfUnknown = True  
 WinErrorToStr,    , Dict  
,      ,  ,
          ,  
  Unassigned (WinInetErrorToStr);   
         StatusCode,
Dict   ,     
,  ,         
 ,     Unassigned
(WinInetStatusCodeErrorToStr)}
function WinInetErrorToStr(ErrorCode: Integer;
  CallWindowsIfUnknown: Boolean; const Dict: Variant): string;
function WinInetStatusCodeErrorToStr(StatusCode: Integer;
  const Dict: Variant): string;



{---      -----------------------------------}



{---    -------------------------------------------------}



{---  COM -------------------------------------------------------------}

{ IActiveScript}
type
  IActiveScriptSite =           interface;
  IActiveScriptSiteWindow =     interface;
  IActiveScript =               interface;
  IActiveScriptParse =          interface;
  IActiveScriptParseProcedure = interface;
  IActiveScriptError =          interface;
  LPCOLESTR = PWideChar;
  IActiveScriptSite = interface(IUnknown)
    [SID_IActiveScript]
    function GetLCID(out plcid: LCID): HRESULT; stdcall;
    function GetItemInfo(pstrName: LPCOLESTR; dwReturnMask: DWORD;
      out ppiunkItem: IUnknown; out ppti: ITypeInfo): HRESULT; stdcall;
    function GetDocVersionString(out pbstrVersion: WideString): HRESULT;
      stdcall;
    function OnScriptTerminate(const pvarResult: OleVariant;
      const pexcepinfo: TExcepInfo): HRESULT; stdcall;
    function OnStateChange(ssScriptState: TScriptState): HRESULT; stdcall;
    function OnScriptError(const pscripterror: IActiveScriptError): HRESULT;
      stdcall;
    function OnEnterScript: HRESULT; stdcall;
    function OnLeaveScript: HRESULT; stdcall;
  end;
  IActiveScriptError = interface(IUnknown)
    [SID_IActiveScriptError]
    function GetExceptionInfo(out pexcepinfo: TExcepInfo): HRESULT; stdcall;
    function GetSourcePosition(out pdwSourceContext: DWORD;
      out pulLineNumber: ULONG; out plCharacterPosition: Integer): HRESULT;
      stdcall;
    function GetSourceLineText(out pbstrSourceLine: WideString): HRESULT;
      stdcall;
  end;
  IActiveScriptSiteWindow = interface(IUnknown)
    [SID_IActiveScriptSiteWindow]
    function GetWindow(out phwnd: HWND): HRESULT; stdcall;
    function EnableModeless(fEnable: BOOL): HRESULT; stdcall;
  end;
  IActiveScriptSiteInterruptPoll = interface(IUnknown)
    [SID_IActiveScriptSiteInterruptPoll]
    function QueryContinue: HRESULT; stdcall;
  end;
  IActiveScript = interface(IUnknown)
    [SID_IActiveScript]
    function SetScriptSite(const pass: IActiveScriptSite): HRESULT; stdcall;
    function GetScriptSite(const riid: TGUID; out ppvObject: Pointer): HRESULT;
      stdcall;
    function SetScriptState(ss: TScriptState): HRESULT; stdcall;
    function GetScriptState(out pssState: TScriptState): HRESULT; stdcall;
    function Close: HRESULT; stdcall;
    function AddNamedItem(pstrName: LPCOLESTR; dwFlags: DWORD): HRESULT;
      stdcall;
    function AddTypeLib(const rguidTypeLib: TGUID; dwMajor: DWORD;
      dwMinor: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function GetScriptDispatch(pstrItemName: LPCOLESTR;
      out ppdisp: IDispatch): HRESULT; stdcall;
    function GetCurrentScriptThreadID(
      out pstidThread: TScriptThreadId): HRESULT; stdcall;
    function GetScriptThreadID(dwWin32ThreadId: DWORD;
      out pstidThread: TScriptThreadId): HRESULT; stdcall;
    function GetScriptThreadState(stidThread: TScriptThreadId;
      out pstsState: TScriptThreadState): HRESULT; stdcall;
    function InterruptScriptThread(stidThread: TScriptThreadId;
      const pexcepinfo: TExcepInfo; dwFlags: DWORD): HRESULT; stdcall;
    function Clone(out ppscript: IActiveScript): HRESULT; stdcall;
  end;
  IActiveScriptParse = interface(IUnknown)
    [SID_IActiveScriptParse]
    function InitNew: HRESULT; stdcall;
    function AddScriptlet(pstrDefaultName: LPCOLESTR; pstrCode: LPCOLESTR;
      pstrItemName: LPCOLESTR; pstrSubItemName: LPCOLESTR;
      pstrEventName: LPCOLESTR; pstrDelimiter: LPCOLESTR;
      dwSourceContextCookie: DWORD; ulStartingLineNumber: ULONG;
      dwFlags: DWORD; out pbstrName: WideString;
      out pexcepinfo: TExcepInfo): HRESULT; stdcall;
    function ParseScriptText(pstrCode: LPCOLESTR; pstrItemName: LPCOLESTR;
      const punkContext: IUnknown; pstrDelimiter: LPCOLESTR;
      dwSourceContextCookie: DWORD; ulStartingLineNumber: ULONG;
      dwFlags: DWORD; out pvarResult: OleVariant;
      out pexcepinfo: TExcepInfo): HRESULT; stdcall;
  end;
  IActiveScriptParseProcedureOld = interface(IUnknown)
    [SID_IActiveScriptParseProcedureOld]
    function ParseProcedureText(pstrCode: LPCOLESTR;
      pstrFormalParams: LPCOLESTR; pstrItemName: LPCOLESTR;
      const punkContext: IUnknown; pstrDelimiter: LPCOLESTR;
      dwSourceContextCookie: DWORD; ulStartingLineNumber: ULONG;
      dwFlags: DWORD; out ppdisp: IDispatch): HRESULT; stdcall;
  end;
  IActiveScriptParseProcedure = interface(IUnknown)
    [SID_IActiveScriptParseProcedure]
    function ParseProcedureText(pstrCode: LPCOLESTR;
      pstrFormalParams: LPCOLESTR; pstrProcedureName: LPCOLESTR;
      pstrItemName: LPCOLESTR; const punkContext: IUnknown;
      pstrDelimiter: LPCOLESTR; dwSourceContextCookie: DWORD;
      ulStartingLineNumber: ULONG; dwFlags: DWORD;
      out ppdisp: IDispatch): HRESULT; stdcall;
  end;
  IBindEventHandler = interface(IUnknown)
    [SID_IBindEventHandler]
    function BindHandler(pstrEvent: LPCOLESTR;
      const pdisp: IDispatch): HRESULT; stdcall;
  end;
  IActiveScriptStats = interface(IUnknown)
    [SID_IActiveScriptStats]
    function GetStat(stid: DWORD; out pluHi: ULONG;
      out pluLo: ULONG): HRESULT; stdcall;
    function GetStatEx(const guid: TGUID; out pluHi: ULONG;
      out pluLo: ULONG): HRESULT; stdcall;
    function ResetStats: HRESULT; stdcall;
  end;
{ ,     
 }
type
  TInvokeInfo = packed record
    ADispId: Integer;
    InvokeFlags: Word;
    ParamFlags: TInvokeParams;
    ResultFlags: TInvokeResult;
    Params: PDispParams;
    Result: POleVariant;
  end;
{      Number,   1, 
    Info,      ,
 DefValue (VPrmDef);    
  Number,   1,      Info,  
   ,  Unassigned (VPrm); 
     Number,   1,  
   Info,    True,    
  ,  False (VSet);   Value
     Info,  ,   
  ,     True,   
  ,  False (VRes)}
function VPrmDef(const Info: TInvokeInfo; Number: Integer;
  const DefValue: OleVariant): OleVariant;
function VPrm(const Info: TInvokeInfo; Number: Integer): OleVariant;
function VSet(var Info: TInvokeInfo; Number: Integer;
  const Value: OleVariant): Boolean;
function VRes(var Info: TInvokeInfo; const Value: OleVariant): Boolean;
{  ,       
    IsSysDebug  True (TInterfacedObjectDbg);
   (TInterfacedObjectStd)}
type
  TInterfacedObjectDbg = class(TInterfacedObject)
  private
  protected
  public
    constructor Create;
    destructor Destroy; override;
  end;
  TInterfacedObjectStd = {$IFNDEF NODEBUG_SYS} TInterfacedObjectDbg
    {$ELSE} TInterfacedObject {$ENDIF};
{     IDispatch}
type
  TCustomDispatchObject = class(TObjectStd)
  private
    FData: Pointer;
    FObject: TObject;
  protected
    {   NewObject,    
     }
    procedure SetObject(NewObject: TObject); virtual;
  public
    constructor Create;
    {}
    {   IDispatch,    
    nil}
    function GetInterface: IDispatch; virtual;
    {}
    {    (Data);   (AnObject)}
    property Data: Pointer read FData write FData;
    property AnObject: TObject read FObject write SetObject;
  end;
{       IDispatch,  
        }
type
  TDispatchedObjectRef = class(TInterfacedObjectStd, IDispatch)
  private
    FOnGetTypeInfoCount: TGetTypeInfoCountMethod;
    FOnGetTypeInfo: TGetTypeInfoMethod;
    FOnGetIDsOfNames: TGetIDsOfNamesMethod;
    FOnInvoke: TInvokeMethod;
  protected
    function GetTypeInfoCount(out Count: Integer): HRESULT; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer;
      out TypeInfo): HRESULT; stdcall;
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HRESULT; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID;
      LocaleID: Integer; Flags: Word; var Params; VarResult, ExcepInfo,
      ArgErr: Pointer): HRESULT; stdcall;
  public
    constructor Create;
    {}
    {   IDispatch GetTypeInfoCount, GetTypeInfo,
    GetIDsOfNames, Invoke,   ,    }
    property OnGetTypeInfoCount: TGetTypeInfoCountMethod
      read FOnGetTypeInfoCount write FOnGetTypeInfoCount;
    property OnGetTypeInfo: TGetTypeInfoMethod
      read FOnGetTypeInfo write FOnGetTypeInfo;
    property OnGetIDsOfNames: TGetIDsOfNamesMethod
      read FOnGetIDsOfNames write FOnGetIDsOfNames;
    property OnInvoke: TInvokeMethod read FOnInvoke write FOnInvoke;
  end;



{---  ------------------------------------------------------------}



{---  --------------------------------------------------------------------}

{ GDI+}
const
  GDIPlusLib = 'GDIPLUS.DLL';
const
  GDIPLUSSTATUS_OK                        =  0;
  GDIPLUSSTATUS_GENERICERROR              =  1;
  GDIPLUSSTATUS_INVALIDPARAMETER          =  2;
  GDIPLUSSTATUS_OUTOFMEMORY               =  3;
  GDIPLUSSTATUS_OBJECTBUSY                =  4;
  GDIPLUSSTATUS_INSUFFICIENTBUFFER        =  5;
  GDIPLUSSTATUS_NOTIMPLEMENTED            =  6;
  GDIPLUSSTATUS_WIN32ERROR                =  7;
  GDIPLUSSTATUS_WRONGSTATE                =  8;
  GDIPLUSSTATUS_ABORTED                   =  9;
  GDIPLUSSTATUS_FILENOTFOUND              = 10;
  GDIPLUSSTATUS_VALUEOVERFLOW             = 11;
  GDIPLUSSTATUS_ACCESSDENIED              = 12;
  GDIPLUSSTATUS_UNKNOWNIMAGEFORMAT        = 13;
  GDIPLUSSTATUS_FONTFAMILYNOTFOUND        = 14;
  GDIPLUSSTATUS_FONTSTYLENOTFOUND         = 15;
  GDIPLUSSTATUS_NOTTRUETYPEFONT           = 16;
  GDIPLUSSTATUS_UNSUPPORTEDGDIPLUSVERSION = 17;
  GDIPLUSSTATUS_GDIPLUSNOTINITIALIZED     = 18;
  GDIPLUSSTATUS_PROPERTYNOTFOUND          = 19;
  GDIPLUSSTATUS_PROPERTYNOTSUPPORTED      = 20;
const
  GDIPLUSDEBUGEVENTLEVEL_FATAL   = 0;
  GDIPLUSDEBUGEVENTLEVEL_WARNING = 1;
{ GDI+}
type
  TGDIPlusStatus = Integer;
  TGDIPlusDebugEventLevel = Integer;
  TGDIPlusDebugEventProc = procedure(Level: TGDIPlusDebugEventLevel;
    AMessage: PChar); stdcall;
  TGDIPlusStartupInput = packed record
    GdiplusVersion: Cardinal; {must be 1}
    DebugEventCallback: TGDIPlusDebugEventProc; {ignored on free builds}
    SuppressBackgroundThread: BOOL; {False if hooks not used}
    SuppressExternalCodecs: BOOL; {False if not only GDI+ image codecs used}
  end;
  PGDIPlusStartupInput = ^TGDIPlusStartupInput;
  TGDIPlusNotificationHookProc = function(out token:
    ULONG): TGDIPlusStatus; stdcall;
  TGDIPlusNotificationUnhookProc = procedure(token: ULONG); stdcall;
  TGDIPlusStartupOutput = packed record
    NotificationHook: TGDIPlusNotificationHookProc;
    NotificationUnhook: TGDIPlusNotificationUnhookProc;
  end;
  PGDIPlusStartupOutput = ^TGDIPlusStartupOutput;
  TGDIPlusBitmap = Integer;
  TGDIPlusARGB = DWORD;
{ GDI+}
type
  TGdiplusStartupFunc = function(out Token: ULONG; Input: PGDIPlusStartupInput;
    Output: PGdiplusStartupOutput): TGDIPlusStatus; stdcall;
  TGdiplusShutdownProc = procedure(Token: ULONG); stdcall;
  TGdipCreateBitmapFromStreamFunc = function(Stream: IStream;
    out Bitmap: TGDIPlusBitmap): TGDIPlusStatus; stdcall;
  TGdipCreateBitmapFromFileFunc = function(FileName: PWideChar;
    out Bitmap: TGDIPlusBitmap): TGDIPlusStatus; stdcall;
  TGdipCreateHBITMAPFromBitmapFunc = function(Bitmap: TGDIPlusBitmap;
    out hbmReturn: HBITMAP; Background: TGDIPlusARGB): TGDIPlusStatus; stdcall;
{   GDI+    ErrorCode,  
GDIPLUSSTATUS_OK       }
function GDIPlusErrorToStr(ErrorCode: TGDIPlusStatus): string;



{---       ----------------------}

{    }
type
  TCustomCryptoService = class(TObjectStd)
  private
    FExternalLib: string;
    FExternalLibVar: Variant;
    FExternalLibVarDefined: Boolean;
    FIsFileSafe: Boolean;
    FFileSafeInfo: TFileSafeInfo;
    FReadOnlyFileSafeInfo: TFileSafeInfo;
    FWriteOnlyFileSafeInfo: TFileSafeInfo;
    FAuthAlg: string;
    FAuthAlgDefined: Boolean;
    FSignAlg: string;
    FSignAlgDefined: Boolean;
    FProtectAlg: string;
    FProtectAlgDefined: Boolean;
    FCAName: string;
    FCANameDefined: Boolean;
    FInsCertToSign: TNullBool;
    FInsCertToSignDefined: Boolean;
    FNotAllowDialogs: Boolean;
    FParentHandle: HWND;
    FIsServer: Boolean;
  protected
    FPubKey: string;
    FPubKeyData: string;
    FExpCertificate: string;
    {}
    function GetAuthAlg: string;
    procedure SetAuthAlg(const NewAuthAlg: string);
    function GetSignAlg: string;
    procedure SetSignAlg(const NewSignAlg: string);
    function GetProtectAlg: string;
    procedure SetProtectAlg(const NewProtectAlg: string);
    function GetAlg: string;
    procedure SetAlg(const NewAlg: string);
    function GetAlgHint: string;
    function GetCAName: string;
    procedure SetCAName(const NewCAName: string);
    function GetInsCertToSign: TNullBool;
    procedure SetInsCertToSign(const NewInsCertToSign: TNullBool);
    {   (ExternalLibCreate);   
      nil,    (ExternalLibException)}
    function ExternalLibCreate: Variant; virtual;
    function ExternalLibException: TObject; virtual;
    {}
    function RetrieveAuthAlg: string; virtual;
    function RetrieveSignAlg: string; virtual;
    function RetrieveProtectAlg: string; virtual;
    function RetrieveCAName: string; virtual;
    function RetrieveInsCertToSign: TNullBool; virtual;
    {    (ExternalLibClear); 
      (ExternalLibVar);    
    ,     
    (ExternalLibCheck)}
    function ExternalLibClear: Variant;
    function ExternalLibVar: Variant;
    procedure ExternalLibCheck;
  public
    constructor Create;
    {}
    {    }
    function AlgParams(const AlgName: string): TCryptoServiceParams; virtual;
    {}
    {         AlgName,
     C=CommonName, T=Title, OU=OrganizationalUnit, O=Organization,
    L=Locality, S=StateOrProvince, C=Country, E=Email,    
       OtherFields;   ,  PubKey 
    PubKeyData}
    function CertRequest(const AlgName, CommonName, Title, OrganizationalUnit,
      Organization, Locality, StateOrProvince, Country, Email,
      OtherFields: string): string; virtual;
    {  CertStr   AlgName}
    procedure CertAccept(const AlgName, CertStr: string); virtual;
    {}
    {  DataStr   AlgName   
    ,    ;   CryptoAPI
        OwnStoreName,    -  'MY' 
    :   OwnCertificate,  
    OwnSerialNumber,   OwnIssuer,  
    OwnSubject;  IsFile = True   c  DataStr; 
    IsCaching = True      , 
    ,   ;  ; 
    AlgName = 'SCOM',   ALG_SIGNALCOM,   
    - -     mespro.dll; 
    AlgName = 'CPRC',   ALG_CRYPTOC,   
    - -     libcrypt.dll;  
       UserName;  IsMulti    
      DataStr,    GetStrFromArray,  
       GetStrFromArray;  AlgName = 'SCOM',  
    ALG_SIGNALCOM,     PrivateKey,  
    PublicKey     CACertificate,  
      , IsKeysInFiles   ,  
       ,      ; Mode  
      ,  Mode,   'WIN', 
    ,  ,    
    ,   , Params    ini 
        , UserLogins  UserOriginals  
      ,      ,
      GetStrFromArray,  SignUserLogin   
       ,   , OrganizationName
       ,      
            ,
    SiteLink      , CertsScript  
          ,   
     CertExpireParams     
    , UserDateEndOfTrust,   0,   
    , UserDatesEndOfTrust,  ,   
        GetStrFromArray,  SaveNotAcceptedCertsMsgOff
     True      
    }
    function Sign(const AlgName, DataStr, OwnStoreName, OwnCertificate,
      OwnSerialNumber: string; OwnActualSysDate: TDateTime; const OwnIssuer,
      OwnSubject, UserName, PrivateKey, Password, PublicKey,
      CACertificate: string; IsFile, IsKeysInFiles, IsCaching,
      IsMulti: Boolean; const Mode, Params, UserLogins, UserOriginals,
      OrganizationName, SiteLink, CertsScript: string;
      const CertExpireParams: TCertExpireParams; UserDateEndOfTrust: TDateTime;
      const UserDatesEndOfTrust: string; SaveNotAcceptedCertsMsgOff: Boolean;
      out SignUserLogin: string): string; virtual;
    {  SignatureStr  DataStr   AlgName 
     ;   CryptoAPI  
      ClientStoreName,    - 'CA'  :
      ClientCertificate,  
    ClientSerialNumber,  ,    
    ClientActualSysDate,   ClientIssuer  
    ClientSubject;        CryptoAPI,
       ,     'MY' 
    :   OwnCertificate,  
    OwnSerialNumber, ,     OwnActualSysDate, 
     ClientIssuer   ClientSubject;  IsFile = True
       c  DataStr;  IsCaching = True 
        ,  , 
     ;  AlgName = 'SCOM',   ALG_SIGNALCOM, 
       - -    
    mespro.dll;  AlgName = 'CRPC',   ALG_CRYPTOC, 
       - -    
    libcrypt.dll;      UserName;
     IsMulti = False   ,   IsMulti 
       DataStr     SignatureStr,  
    GetStrFromArray,       
        GetStrFromArray,   , 
     ;  AlgName = 'SCOM',   ALG_SIGNALCOM,  
    PublicKey       PublicKey 
       CACertificate,  
     CRL, IsKeysInFiles   ,     
    ,      , IsCertInStr ; Mode
        ,  Mode,  
    'WIN',  ,  ,  
      ,   , Params  
     ini      , OrganizationName
       ,      
            ,
    SiteLink      , CertsScript  
          ,
     SaveNotAcceptedCertsMsgOff  True   
       }
    function Verify(const AlgName, DataStr, SignatureStr, OwnStoreName,
      OwnCertificate, OwnSerialNumber: string; OwnActualSysDate: TDateTime;
      const OwnIssuer, OwnSubject, ClientStoreName, ClientCertificate,
      ClientSerialNumber: string; ClientActualSysDate: TDateTime;
      const ClientIssuer, ClientSubject, UserName, PublicKey, CACertificate,
      CRL: string; IsFile, IsKeysInFiles, IsCertInStr, IsCaching,
      IsMulti: Boolean; const Mode, Params, OrganizationName, SiteLink,
      CertsScript: string;
      SaveNotAcceptedCertsMsgOff: Boolean): string; virtual;
    {}
    {  SourDataStr   AlgName   
    SymmetricKey,    -  ,    
     -   OwnCertificate, OwnSerialNumber, OwnActualSysDate,
    OwnIssuer, OwnSubject  CertSign -     -
      ClientCertificate, ClientSerialNumber, ClientActualSysDate,
    ClientIssuer, ClientSubject,  CertVerify,  
     ;  IsFile = True    
    SourDataStr,     DestDataStr;  IsCaching = True
         ,  ,
      }
    function Protect(const AlgName, SourDataStr, DestDataStr,
      SymmetricKey, OwnCertificate, OwnSerialNumber: string;
      OwnActualSysDate: TDateTime; const OwnIssuer, OwnSubject,
      ClientCertificate, ClientSerialNumber: string;
      ClientActualSysDate: TDateTime; const ClientIssuer,
      ClientSubject: string; IsFile, IsCaching: Boolean): string; virtual;
    {  SourDataStr   AlgName   
    SymmetricKey,    -  ,    
     -   OwnCertificate, OwnSerialNumber, OwnActualSysDate,
    OwnIssuer, OwnSubject  CertSign -     -
      ClientCertificate, ClientSerialNumber, ClientActualSysDate,
    ClientIssuer, ClientSubject,  CertVerify,  
     ;  IsFile = True    
    SourDataStr,     DestDataStr;  IsCaching = True
         ,  ,
      }
    function Unprotect(const AlgName, SourDataStr, DestDataStr,
      SymmetricKey, OwnCertificate, OwnSerialNumber: string;
      OwnActualSysDate: TDateTime; const OwnIssuer, OwnSubject,
      ClientCertificate, ClientSerialNumber: string;
      ClientActualSysDate: TDateTime; const ClientIssuer,
      ClientSubject: string; IsFile, IsCaching: Boolean): string; virtual;
    {}
    { True,  E -  , 
    IsVerifyError = True -   }
    function IsCryptoError(E: TObject; IsVerifyError: Boolean): Boolean;
      virtual;
    {    AlgName; CertStr -  
      Base64 ;  FieldName 
    Request.ClientCertificate  ASP:
    'Certificate' - ,       ;
    'SerialNumber' -       
    ,     'SCOM',   ALG_SIGNALCOM;
    'ValidFrom' -      
    'dd.mm.yyyy hh:nn:ss';
    'ValidUntil' -      
    'dd.mm.yyyy hh:nn:ss';
    'Subject' -  ; 'SubjectCN', 'SubjectO'  .. -
        ,   
     'SCOM',   ALG_SIGNALCOM;
    'Issuer' -  ; 'IssuerCN', 'IssuerO'  .. - 
       ),    
    'SCOM',   ALG_SIGNALCOM;
    'Version' -  ;
    'SignatureAlgorithm' -  ;
    'Algorithm' -   ;
    'PublicKey' -       ;
    'PublicKeyBits' -     ;
    'AlgName' -       ,
           CertSign,
    CertVerify;
          :
    'Request' - ,       ;
    'RequestSubject' - ,   , 'RequestSubjectCN',
    'RequestSubjectO'  .. -     ;
    'RequestVersion' -   ;
    'RequestAlgorithm' -    ;
    'RequestPublicKey' -     ;
    'RequestPublicKeyBits' -      ;
    'RequestAlgName' -      
    ,       
    CertSign, CertVerify;    ,     
    ,     ;  RSA  SHA1}
    function CertField(const AlgName, CertStr, FieldName: string): string;
      virtual;
    {    SignatureStr,   
    AlgName  'SCOM',   ALG_SIGNALCOM,   ,  
         ,   }
    function SignatureCert(const AlgName, SignatureStr: string): string;
      virtual;
    { ,      PublicKey 
          AlgName,  
    ,    CryptoAPI   
       PublicKey    
    }
    function PublicKeyData(const AlgName, PublicKey: string): string; virtual;
    {  CertStr   AlgName   
      CACertStr,  ,   
    CACRLStr,  ,  -      
     CAName,    ,   
     ,   ,  
    }
    procedure VerifyCert(const AlgName, CAName, CACertStr, CACRLStr,
      CertStr: string); virtual;
    {  CertStr   AlgName   StoreName,
     StoreName = ''    ,   'CA'
      CryptoAPI,  True,   ,
    False,  ,      }
    function AddCert(const AlgName, CertStr, StoreName: string): Boolean;
      virtual;
    {    AlgName,  
    Certificate,   Wnd,  Title,  
       ,  IsFile = True Certificate 
    CertFindCertificate,   ,     
     ,    Certificate   
          AlgName = 'SCOM'   
       , IsMulti   
       GetStrFromArray,   IsSignature = True,
    IsSignature = True ,    ,   
    -,  ,   AlgName = 'SCOM',
    AllowCancel = True      ,   
     False, True     OK,  AlgName 
     'SCOM'  Crypto API,  Certificate = '', 
       CertFindStoreName,    'CA',
      CertFindCertificate,  ,  
    CertFindSerialNumber,  ,  CertFindActualSysDate,  ,
          ,   
     CertFindIssuer    ,   
     CertFindSubject    ,  CertFindWithPrivateKey
     True     ,   Certificate,
    CertFindStoreName, CertFindCertificate, CertFindSerialNumber,
    CertFindIssuer, CertFindSubject   ,
    CertFindActualSysDate  0, CertFindWithPrivateKey  False,
          }
    function CertView(const AlgName, Certificate: string; Wnd: HWND;
      const Title: string; IsFile, IsMulti, IsSignature, AllowCancel: Boolean;
      const CertFindStoreName, CertFindCertificate,
      CertFindSerialNumber: string; CertFindActualSysDate: TDateTime;
      const CertFindIssuer, CertFindSubject: string;
      CertFindWithPrivateKey: Boolean): Boolean; virtual;
    {   Param   AlgName,  
    AlgName  'SCOM'  Param,  'CERT',  
      Inter-PRO,  'ISPSE'  '1'   PSE 
    Inter-PRO,  '0'      
    Inter-PRO,  'PRIVKEY'    Inter-PRO, 
    'PSEDIR'   PSE Inter-PRO,  'CACERT' 
        Inter-PRO,  'CRL' 
      Inter-PRO,  'CACHED_'   
        , Data    
       GetStrFromArray,    Inter-PRO
       ,      Data
    ,     }
    function CryptoParam(const AlgName, Param, Data: string): string; virtual;
    {}
    {    RequestStr, AlgName  , CAName -
      ,    , 
       ,   
    }
    function AcceptRequest(const AlgName, CAName, RequestStr: string): Integer;
      virtual;
    {      CertId, AlgName 
    , CAName -   ,    ,
        ,  }
    function IssueCert(const AlgName, CAName: string; CertId: Integer): string;
      virtual;
    {     SerialNumber; AlgName 
    , CAName -   ,    ,
        }
    procedure RevokeCert(const AlgName, CAName, SerialNumber: string);
      virtual;
    {}
    {       FieldNames   ExportFormat,
           
     }
    procedure ImportFieldNames(const FieldNames,
      ExportFormat: string); virtual;
    {}
    { ActiveX-   ,   ,
       }
    property ExternalLib: string read FExternalLib write FExternalLib;
    {      (IsFileSafe); 
            (FileSafeInfo); 
           (ReadOnlyFileSafeInfo);
           
    (WriteOnlyFileSafeInfo)}
    property IsFileSafe: Boolean read FIsFileSafe write FIsFileSafe;
    property FileSafeInfo: TFileSafeInfo
      read FFileSafeInfo write FFileSafeInfo;
    property ReadOnlyFileSafeInfo: TFileSafeInfo
      read FReadOnlyFileSafeInfo write FReadOnlyFileSafeInfo;
    property WriteOnlyFileSafeInfo: TFileSafeInfo
      read FWriteOnlyFileSafeInfo write FWriteOnlyFileSafeInfo;
    { ,  CertRequest (PubKey);  
    ,     ,   
    (PubKeyData); ,    (ExpCertificate)}
    property PubKey: string read FPubKey;
    property PubKeyData: string read FPubKeyData;
    property ExpCertificate: string read FExpCertificate;
    {}
    {   (AuthAlg);    (SignAlg);
       (ProtectAlg)}
    property AuthAlg: string read GetAuthAlg write SetAuthAlg;
    property SignAlg: string read GetSignAlg write SetSignAlg;
    property ProtectAlg: string read GetProtectAlg write SetProtectAlg;
    { ,   ,   
    AuthAlg,   , SignAlg,   , ProtectAlg,  
       AuthAlg, SignAlg, ProtectAlg (Alg); 
       ,    ,
     ,    (AlgHint)}
    property Alg: string read GetAlg write SetAlg;
    property AlgHint: string read GetAlgHint;
    {   (CAName);     
    (InsCertToSign)}
    property CAName: string read GetCAName write SetCAName;
    property InsCertToSign: TNullBool
      read GetInsCertToSign write SetInsCertToSign;
    {   ,   False (NotAllowDialogs);
         (ParentHandle); 
          (IsServer)}
    property NotAllowDialogs: Boolean
      read FNotAllowDialogs write FNotAllowDialogs;
    property ParentHandle: HWND read FParentHandle write FParentHandle;
    property IsServer: Boolean read FIsServer write FIsServer;
  end;



{---  -------------------------------------------------------------}

{ SAX, Simple API for XML}
type
  ISAXEntityResolver = interface;
  ISAXContentHandler = interface;
  ISAXLocator = interface;
  ISAXAttributes = interface;
  ISAXDTDHandler = interface;
  ISAXErrorHandler = interface;
  ISAXXMLReader = interface(IUnknown)
    [SID_ISAXXMLReader]
    function getFeature(pwchName: PWideChar;
      out pvfValue: WordBool): HRESULT; stdcall;
    function putFeature(pwchName: PWideChar;
      vfValue: WordBool): HRESULT; stdcall;
    function getProperty(pwchName: PWideChar;
      out pvarValue: OleVariant): HRESULT; stdcall;
    function putProperty(pwchName: PWideChar;
      varValue: OleVariant): HRESULT; stdcall;
    function getEntityResolver(out ppResolver:
      ISAXEntityResolver): HRESULT; stdcall;
    function putEntityResolver(const pResolver:
      ISAXEntityResolver): HRESULT; stdcall;
    function getContentHandler(out ppHandler:
      ISAXContentHandler): HRESULT; stdcall;
    function putContentHandler(const pHandler:
      ISAXContentHandler): HRESULT; stdcall;
    function getDTDHandler(out ppHandler: ISAXDTDHandler): HRESULT; stdcall;
    function putDTDHandler(const pHandler: ISAXDTDHandler): HRESULT; stdcall;
    function getErrorHandler(out ppHandler:
      ISAXErrorHandler): HRESULT; stdcall;
    function putErrorHandler(const pHandler:
      ISAXErrorHandler): HRESULT; stdcall;
    function getBaseURL(out ppwchBaseUrl: PWideChar): HRESULT; stdcall;
    function putBaseURL(pwchBaseUrl: PWideChar): HRESULT; stdcall;
    function getSecureBaseURL(out ppwchSecureBaseUrl: PWideChar): HRESULT;
      stdcall;
    function putSecureBaseURL(pwchSecureBaseUrl: PWideChar): HRESULT; stdcall;
    function parse(varInput: OleVariant): HRESULT; stdcall;
    function parseURL(pwchUrl: PWideChar): HRESULT; stdcall;
  end;
  ISAXEntityResolver = interface(IUnknown)
    [SID_ISAXEntityResolver]
    function resolveEntity(pwchPublicId, pwchSystemId: PWideChar;
      out pvarInput: OleVariant): HRESULT; stdcall;
  end;
  ISAXContentHandler = interface(IUnknown)
    [SID_ISAXContentHandler]
    function putDocumentLocator(const pLocator: ISAXLocator): HRESULT; stdcall;
    function startDocument: HRESULT; stdcall;
    function endDocument: HRESULT; stdcall;
    function startPrefixMapping(pwchPrefix: PWideChar; cchPrefix: Integer;
      pwchUri: PWideChar; cchUri: Integer): HRESULT; stdcall;
    function endPrefixMapping(pwchPrefix: PWideChar;
      cchPrefix: Integer): HRESULT; stdcall;
    function startElement(pwchNamespaceUri: PWideChar;
      cchNamespaceUri: Integer; pwchLocalName: PWideChar;
      cchLocalName: Integer; pwchQName: PWideChar; cchQName: Integer;
      const pAttributes: ISAXAttributes): HRESULT; stdcall;
    function endElement(pwchNamespaceUri: PWideChar; cchNamespaceUri: Integer;
      pwchLocalName: PWideChar; cchLocalName: Integer; pwchQName: PWideChar;
      cchQName: Integer): HRESULT; stdcall;
    function characters(pwchChars: PWideChar;
      cchChars: Integer): HRESULT; stdcall;
    function ignorableWhitespace(pwchChars: PWideChar;
      cchChars: Integer): HRESULT; stdcall;
    function processingInstruction(pwchTarget: PWideChar; cchTarget: Integer;
      pwchData: PWideChar; cchData: Integer): HRESULT; stdcall;
    function skippedEntity(pwchName: PWideChar;
      cchName: Integer): HRESULT; stdcall;
  end;
  ISAXLocator = interface(IUnknown)
    [SID_ISAXLocator]
    function getColumnNumber(out pnColumn: Integer): HRESULT; stdcall;
    function getLineNumber(out pnLine: Integer): HRESULT; stdcall;
    function getPublicId(out ppwchPublicId: PWideChar): HRESULT; stdcall;
    function getSystemId(out ppwchSystemId: PWideChar): HRESULT; stdcall;
  end;
  ISAXAttributes = interface(IUnknown)
    [SID_ISAXAttributes]
    function getLength(out pnLength: Integer): HRESULT; stdcall;
    function getURI(nIndex: Integer; out ppwchUri: PWideChar;
      out pcchUri: Integer): HRESULT; stdcall;
    function getLocalName(nIndex: Integer; out ppwchLocalName: PWideChar;
      out pcchLocalName: Integer): HRESULT; stdcall;
    function getQName(nIndex: Integer; out ppwchQName: PWideChar;
      out pcchQName: Integer): HRESULT; stdcall;
    function getName(nIndex: Integer; out ppwchUri: PWideChar;
      out pcchUri: Integer; out ppwchLocalName: PWideChar;
      out pcchLocalName: Integer; out ppwchQName: PWideChar;
      out pcchQName: Integer): HRESULT; stdcall;
    function getIndexFromName(pwchUri: PWideChar; cchUri: Integer;
      pwchLocalName: PWideChar; cchLocalName: Integer;
      out pnIndex: Integer): HRESULT; stdcall;
    function getIndexFromQName(pwchQName: PWideChar; cchQName: Integer;
      out pnIndex: Integer): HRESULT; stdcall;
    function getType(nIndex: Integer; out ppwchType: PWideChar;
      out pcchType: Integer): HRESULT; stdcall;
    function getTypeFromName(pwchUri: PWideChar; cchUri: Integer;
      pwchLocalName: PWideChar; cchLocalName: Integer;
      out ppwchType: PWideChar; out pcchType: Integer): HRESULT; stdcall;
    function getTypeFromQName(pwchQName: PWideChar; cchQName: Integer;
      out ppwchType: PWideChar; out pcchType: Integer): HRESULT; stdcall;
    function getValue(nIndex: Integer; out ppwchValue: PWideChar;
      out pcchValue: Integer): HRESULT; stdcall;
    function getValueFromName(pwchUri: PWideChar; cchUri: Integer;
      pwchLocalName: PWideChar; cchLocalName: Integer;
      out ppwchValue: PWideChar; out pcchValue: Integer): HRESULT; stdcall;
    function getValueFromQName(pwchQName: PWideChar; cchQName: Integer;
      out ppwchValue: PWideChar; out pcchValue: Integer): HRESULT; stdcall;
  end;
  ISAXDTDHandler = interface(IUnknown)
    [SID_ISAXDTDHandler]
    function notationDecl(pwchName: PWideChar; cchName: Integer;
      pwchPublicId: PWideChar; cchPublicId: Integer; pwchSystemId: PWideChar;
      cchSystemId: Integer): HRESULT; stdcall;
    function unparsedEntityDecl(pwchName: PWideChar; cchName: Integer;
      pwchPublicId: PWideChar; cchPublicId: Integer; pwchSystemId: PWideChar;
      cchSystemId: Integer; pwchNotationName: PWideChar;
      cchNotationName: Integer): HRESULT; stdcall;
  end;
  ISAXErrorHandler = interface(IUnknown)
    [SID_ISAXErrorHandler]
    function error(const pLocator: ISAXLocator; pwchErrorMessage: PWideChar;
      hrErrorCode: HRESULT): HRESULT; stdcall;
    function fatalError(const pLocator: ISAXLocator;
      pwchErrorMessage: PWideChar; hrErrorCode: HRESULT): HRESULT; stdcall;
    function ignorableWarning(const pLocator: ISAXLocator;
      pwchErrorMessage: PWideChar; hrErrorCode: HRESULT): HRESULT; stdcall;
  end;
  IMXWriter = interface(IDispatch)
    [SID_IMXWriter]
    procedure Set_output(varDestination: OleVariant); safecall;
    function Get_output: OleVariant; safecall;
    procedure Set_encoding(const strEncoding: WideString); safecall;
    function Get_encoding: WideString; safecall;
    procedure Set_byteOrderMark(fWriteByteOrderMark: WordBool); safecall;
    function Get_byteOrderMark: WordBool; safecall;
    procedure Set_indent(fIndentMode: WordBool); safecall;
    function Get_indent: WordBool; safecall;
    procedure Set_standalone(fValue: WordBool); safecall;
    function Get_standalone: WordBool; safecall;
    procedure Set_omitXMLDeclaration(fValue: WordBool); safecall;
    function Get_omitXMLDeclaration: WordBool; safecall;
    procedure Set_version(const strVersion: WideString); safecall;
    function Get_version: WideString; safecall;
    procedure Set_disableOutputEscaping(fValue: WordBool); safecall;
    function Get_disableOutputEscaping: WordBool; safecall;
    procedure flush; safecall;
    property output: OleVariant read Get_output write Set_output;
    property encoding: WideString read Get_encoding write Set_encoding;
    property byteOrderMark: WordBool
      read Get_byteOrderMark write Set_byteOrderMark;
    property indent: WordBool read Get_indent write Set_indent;
    property standalone: WordBool read Get_standalone write Set_standalone;
    property omitXMLDeclaration: WordBool
      read Get_omitXMLDeclaration write Set_omitXMLDeclaration;
    property version: WideString read Get_version write Set_version;
    property disableOutputEscaping: WordBool
      read Get_disableOutputEscaping write Set_disableOutputEscaping;
  end;



{---    --------------------------------------------------------}




